//###########################################################################
//# ftpbnc 0.2 by comrade
//# comrade2k@hotmail.com
//# http://comrade64.cjb.net/
//###########################################################################
//###########################################################################
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
//###########################################################################
typedef struct {
	int  lsock;
	int  rsock;
	char status;
} CONN;
//###########################################################################
#define DATA_SIZE 8192
#define MAX_SOCKETS 128
#define LOG_LEVEL 0
//###########################################################################
CONN conns[MAX_SOCKETS];
int lsock, csock, rsock, sockets=0;
char *local, *remote;
char *welcome   = "220 [ftpbnc 0.2 by comrade] ready\x0D\x0A";
char *passwdreq = "331 Password required.\x0D\x0A";
char *loggedin  = "230 User logged in.\x0D\x0A";
char *loginbad  = "530 Login incorrect.\x0D\x0A";
//char *badcmd    = "530 Bad command.\x0D\x0A";
//###########################################################################
int main(int, char**);
void log(unsigned int, const char*, ...);
void remove_conn(unsigned int);
void freeres();
void quit(const char*);
void sigterm(int);
//###########################################################################
//###########################################################################
//###########################################################################
//###########################################################################
int main(int argc, char **argv){
	FILE* hFile; unsigned char pid[16]; char *lhost, *rhost, *lport, *rport;
	struct sockaddr_in lsin, sin; struct hostent *hp; fd_set in; struct timeval tv;
	unsigned int localb, remoteb, i;

	log(0, "  ftpbnc 0.2 by comrade\n  comrade2k@hotmail.com\n  http://comrade64.cjb.net/");
	if (argc != 5){
		log(0, "Usage: ftpbnc listenhost listenport username password");
		return 0;
	}
	//signal(SIGHUP, SIG_IGN);
	signal(SIGTERM, sigterm);
	if (fork()) return 0;	// parent
	lhost = argv[1];
	lport = argv[2];
	*(lport-1)=0;

	hFile = fopen("ftpbnc.pid", "wb");
	fwrite(&pid, sprintf(pid, "%lu\n", getpid()), 1, hFile);
	fclose(hFile);
	log(0, "\nSuccessfully loaded into background (PID %lu)...", getpid());
	if ((lsock = socket(AF_INET, SOCK_STREAM, 0)) == -1) quit("Failed to create socket!");
	i = 1;
	if (setsockopt(lsock, SOL_SOCKET, SO_REUSEADDR, &i, sizeof(i))) quit("Failed to set socket options!");
	lsin.sin_family = AF_INET; lsin.sin_port = htons(atoi(lport));
	if ((lsin.sin_addr.s_addr = inet_addr(lhost)) == INADDR_NONE){
		if (!(hp = gethostbyname(lhost))) quit("Invalid listen hostname!");
		memcpy(&lsin.sin_addr, hp->h_addr, hp->h_length);
	}
	if (bind(lsock, (struct sockaddr*)&lsin, sizeof(lsin))) quit("Failed to bind socket!");
	if (listen(lsock, 5)) quit("Failed to listen on socket!");
	remote = malloc(DATA_SIZE);
	local = malloc(DATA_SIZE);
	while(1){
		// accept new connections
		FD_ZERO(&in);
		FD_SET(lsock, &in);
		tv.tv_sec = 0; tv.tv_usec = 150;
		if (select(lsock+1, &in, 0, 0, &tv)){
			if (FD_ISSET(lsock, &in)){
				if ((csock = accept(lsock, 0, 0)) > 0){
					log(1, "=================\nNew client");
					fcntl(csock, F_SETFL, O_NONBLOCK);
					conns[sockets  ].lsock = csock;
					conns[sockets++].rsock = 0;
					send(csock, welcome, strlen(welcome), 0);
				}
			}
		}
		// bounce data
		for(i = 0; i < sockets; i++){
			memset( local, 0, DATA_SIZE);
			memset(remote, 0, DATA_SIZE);
			if      ((conns[i].lsock) && !( localb = recv(conns[i].lsock,  local, DATA_SIZE, 0))) remove_conn(i);
			else if ((conns[i].rsock) && !(remoteb = recv(conns[i].rsock, remote, DATA_SIZE, 0))) remove_conn(i);
			else {
				if (conns[i].lsock && !conns[i].rsock && localb && (localb <= DATA_SIZE)){ // not connected yet
					local[localb-2] = 0;
					log(1, "Received: %s", local);
					if ((conns[i].status==0) && (!strncasecmp(local, "user", 4))){		// check for username
						log(1, "Checking username...");
						if (!strcmp(argv[3], local+5)){
							memcpy(remote, passwdreq, strlen(passwdreq));
							conns[i].status++;
						} else memcpy(remote, loginbad, strlen(loginbad));
						remoteb = strlen(remote);
						localb = 0;
					} else if ((conns[i].status==1) && (!strncasecmp(local, "pass", 4))) {	// check for password
						log(1, "Checking password...");
						if (!strcmp(argv[4], local+5)){
						memcpy(remote, loggedin, strlen(loggedin));
							conns[i].status++;
						} else {
							memcpy(remote, loginbad, strlen(loginbad));
							conns[i].status--;
						}
						remoteb = strlen(remote);
						localb = 0;
					} else if ((conns[i].status==2) && ((!strncasecmp(local, "open", 4)) || (!strncasecmp(local, "site", 4)))) {	// check for host:port
						log(1, "Bouncing...");
						rhost = &local[5];
						if (!(rport = strchr(rhost, ':'))) rport = strchr(rhost, ' ');
						sin.sin_family = AF_INET;
						if (rport){
							*rport++=0;
							sin.sin_port = htons(atoi(rport));
						}
						else sin.sin_port = htons(21);
						log(1, "Connecting to %s:%u...", rhost, ntohs(sin.sin_port));

						rsock = socket(AF_INET, SOCK_STREAM, 0);
						fcntl(rsock, F_SETFL, O_NONBLOCK);
						lsin.sin_port = 0;
						bind(rsock, (struct sockaddr*)&lsin, sizeof(lsin));
						if ((sin.sin_addr.s_addr = inet_addr(rhost)) == INADDR_NONE){
							if (!(hp = gethostbyname(rhost))) break;
							memcpy(&sin.sin_addr, hp->h_addr, hp->h_length);
						}
						if ((!connect(rsock, (struct sockaddr*)&sin, sizeof(sin))) || (errno==EINPROGRESS)){
							log(1, "Connected!");
							conns[i].rsock = rsock;
							conns[i].status++;
						} else remove_conn(i);
						localb = 0; remoteb = 0;
					} else {
						//memcpy(remote, &badcmd, sizeof(badcmd));
						//remoteb = strlen(remote);
						//localb = 0;
						remove_conn(i);
					}
				}
				if (( localb <= DATA_SIZE) &&  localb && conns[i].rsock) send(conns[i].rsock,  local,  localb, 0);
				if ((remoteb <= DATA_SIZE) && remoteb && conns[i].lsock) send(conns[i].lsock, remote, remoteb, 0);
			}
		}
	}
	return 0;
}
//###########################################################################
void log(unsigned int level, const char *format, ...){
	va_list args;
	if (level>LOG_LEVEL) return;
	va_start(args, format);
	vprintf(format, args);
	va_end(args);
	puts("");
	return;
}
//###########################################################################
void remove_conn(unsigned int index){
	log(1, "Removing connection %u", index);
	close(conns[index].lsock); close(conns[index].rsock);
	memcpy(&conns[index], &conns[index+1], (MAX_SOCKETS-index-1)*sizeof(CONN));
	sockets--;
}
//###########################################################################
void freeres(){
	int i=0;
	for(i; i < sockets; i++){
		close(conns[i].lsock); close(conns[i].rsock);
	}
	close(rsock); close(csock); close(lsock);
	free(local);
	free(remote);
}
//###########################################################################
void quit(const char* error){ freeres(); log(0, "Quitting: %s", error); exit(0); }
//###########################################################################
void sigterm(int sig){ freeres(); exit(0); }
//###########################################################################
//###########################################################################
